// C Header File
// Created 01/03/01; 12:45:10
#include <tigcclib.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <alloc.h>
#include <string.h>

	long	LastX1;
	long	LastY1;
	int	LastPosn;
	int	PageNum;

/* Map of walls. This array is used to build the xRay and yRay grids */
/* when checking the x and y vectors */

unsigned char	Grid[] = {
				2,6,4,3,6,5,8,9,2,3,2,6,4,3,6,5,8,9,2,3,
				3,0,0,0,4,0,0,0,0,4,3,0,0,0,4,0,0,0,0,4,
				4,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				3,0,0,0,5,0,3,4,3,0,0,0,0,0,0,0,0,0,0,5,
				2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				9,6,5,8,9,0,4,3,6,0,0,0,0,0,0,0,0,0,0,5,
				8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				6,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				3,4,3,2,9,8,5,6,3,0,0,0,0,0,0,0,0,0,0,5,
				6,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				6,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				6,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				6,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				6,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				6,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				6,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				6,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				6,0,0,0,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,5,
				2,6,4,3,6,5,8,9,2,3,2,6,4,3,6,5,8,9,2,3
			};

#define GRID_WIDTH  20
#define GRID_HEIGHT 20
#define GRID_MAX    GRID_WIDTH * GRID_HEIGHT
#define GRID_XSTEP  64				/* X distance between walls */
#define GRID_YSTEP  64				/* Y distance between walls */
#define GRID_XMAX   GRID_XSTEP * GRID_WIDTH
#define GRID_YMAX   GRID_YSTEP * GRID_HEIGHT

#define res 0		//si resolution de 160, mettre res  1 pour gagner de le vitesse
						//	(incremente la boucle par 2)

#define BITMAP_HEIGHT	64
#define BITMAP_WIDTH	64

		/* Angles used for lookup */
		/*  tables...		  */
/*#define ANGLE_0		0			
#define ANGLE_30	171		
#define ANGLE_45	256
#define ANGLE_60	341
#define ANGLE_90	512
#define ANGLE_180	1024
#define ANGLE_270	1536
#define ANGLE_360	2048
*/

#define ANGLE_0	0			
#define ANGLE_30	85		
#define ANGLE_45	128
#define ANGLE_60	171
#define ANGLE_90	256
#define ANGLE_180	512
#define ANGLE_270	768
#define ANGLE_360	1024

/*#define ANGLE_0	0			
#define ANGLE_30	42		
#define ANGLE_45	63
#define ANGLE_60	84
#define ANGLE_90	128
#define ANGLE_180	256
#define ANGLE_270	384
#define ANGLE_360	512*/

#define KEYFLAGS_ESC     1
#define KEYFLAGS_UP      2
#define KEYFLAGS_DOWN    4
#define KEYFLAGS_LEFT    8
#define KEYFLAGS_RIGHT  16

#define DEC_FACTOR	15			/* Shift factor for fixed pt */
#define DEC_MULT	32768			/* 1 << DEC_FACTOR	     */

unsigned    char    xGrid[(GRID_WIDTH+2) * (GRID_HEIGHT+2)];
unsigned    char    yGrid[(GRID_WIDTH+2) * (GRID_HEIGHT+2)];

	long     *cTable;			/* Cosine table	 */
	long     *sTable;			/* Sine table	 */
	long     *tTable;			/* Tangent table */
//	long		*rcTable;
//	long 		*rsTable;
//	long		*rtTable;

	long     *nxTable;			/* Next X offset per angle */
	long     *nyTable;			/* Next Y offset per angle */

	long	    DstTable[1024];		/* Distance to height table */
//	long	    DstTable[512];		/* Distance to height table */

void *vscreen;
